#include "GL/glut.h"
#include "GL/glui.h"
#include "math.h"
#include "Hair.h"

float Hair::R;
float Hair::B;
float Hair::G;

Hair::Hair(void)
{
}

Hair::~Hair(void)
{
}

void Hair::GenerateHair(float length, const Vert &startPos)
{
	vertices[0] = startPos;
	float angleX = (2.0/HAIR_RESOLUTION)*
		( ((float)rand())/RAND_MAX -.5);
	float phaseX = ((float)rand()/RAND_MAX - .5);
	float angleZ = (2.0/HAIR_RESOLUTION)*
		( ((float)rand())/RAND_MAX -.5);
	float phaseZ = ((float)rand()/RAND_MAX - .5);
	float height = 1 - ((float)rand()/RAND_MAX)/2;

	for (int i = 0; i < HAIR_RESOLUTION; i++) {
		vertices[i] = 
			Vert(startPos.x + .3*tan(.5*pow(i*angleX,3)) + .3*phaseX*i/HAIR_RESOLUTION,
				 startPos.y + i*length/HAIR_RESOLUTION * height,
				 startPos.z + .3*tan(.5*pow(i*angleZ,3)) + .3*phaseZ*i/HAIR_RESOLUTION);
	}
}

void Hair::draw(float alphas[])
{
	glBegin(GL_QUAD_STRIP);
	for (int i = 0; i < HAIR_RESOLUTION; i++) {		
		if (flip[i]) {
			glEnd();
			glBegin(GL_QUAD_STRIP);
		}
		glColor4f(R,G,B,alphas[i]);
		glVertex3f(vertices[i].x,
				   vertices[i].y,
				   vertices[i].z);
		glVertex3f(vertices[i].x+.01,
				   vertices[i].y,
				   vertices[i].z);
	}
	glEnd();

	glBegin(GL_QUAD_STRIP);
	for (int i = 0; i < HAIR_RESOLUTION; i++) {
		if (flip[i]) {
			glEnd();
			glBegin(GL_QUAD_STRIP);
		}
		glColor4f(R,G,B,alphas[i]);
		glVertex3f(vertices[i].x,
				   vertices[i].y,
				   vertices[i].z);
		glVertex3f(vertices[i].x,
				   vertices[i].y,
				   vertices[i].z+.01);
	}
	glEnd();
}

void Hair::draw() 
{
	float alphas[HAIR_RESOLUTION];
	for (int i = 0; i < HAIR_RESOLUTION; i++)
		alphas[i] = 1;
	draw(alphas);
}
