#include "Model.h"
#include "Math.cpp"

Model::Model(void)
{
	triangles = NULL;
}

Model::~Model(void)
{
}

void Model::LoadModel(char *file)
{
	model = glmReadOBJ(file);
	initModel();
}

#define T(x) (model->triangles[(x)])
void Model::initModel()
{
	glmFacetNormals(model);
	glmVertexNormals(model, 90);
	glmUnitize(model);
	numtriangles = model->numtriangles;
	if (triangles) 
		delete triangles;
	triangles = new Triangle[numtriangles];
	
	GLuint i;
	GLMgroup* group = model->groups;
	GLMtriangle* triangle;

	int k = 0;

    while (group) {
        for (i = 0; i < group->numtriangles; i++) {
            triangle = &T(group->triangles[i]);
			for (int j = 0; j < 3; j++) {
				triangles[k].v[j].x = (&model->vertices[3 * triangle->vindices[j]])[0];
				triangles[k].v[j].y = (&model->vertices[3 * triangle->vindices[j]])[1];
				triangles[k].v[j].z = (&model->vertices[3 * triangle->vindices[j]])[2];

				triangles[k].normals[j].x = (&model->normals[3 * triangle->nindices[j]])[0];
				triangles[k].normals[j].y = (&model->normals[3 * triangle->nindices[j]])[1];
				triangles[k].normals[j].z = (&model->normals[3 * triangle->nindices[j]])[2];

				if (model->numtexcoords) {
					triangles[k].texCoords[j].x = (&model->texcoords[2 * triangle->tindices[j]])[0];
					triangles[k].texCoords[j].y = (&model->texcoords[2 * triangle->tindices[j]])[1];
				}
				else
				{ //TODO: will want to do something better here later, like figure out real texcoords!
					triangles[k].texCoords[j].x = 0;
					triangles[k].texCoords[j].y = 0;
				}

			}
			k++;
        }
        group = group->next;
    }
}
